package jello;

public final class ValueInterpreter {
	static public int Interpret(String val)
    {
        short inter = 0;
        boolean wasshort = true;
        try
        {
        	inter = Short.parseShort(val);
        }
        catch (NumberFormatException e)
        {
        	wasshort = false;
        }
        if (wasshort)
            return inter;
        else if (val.equals("REG"))
            return InternalState.GetRegister();
        else if (val.equals("INP"))
            return InternalState.GetInput();
        else if (val.equals("OUT"))
            return InternalState.GetOutput();
        else if (val.length() < 5)
        	return 0;
        else if (val.substring(0, 4).equals("MEM(") && val.substring(val.length()-1, val.length()).equals(")"))
        {
            short index = 0;
            try
            {
            	index = Short.parseShort(val.replace("MEM(","").replace(")",""));
            }
            catch (NumberFormatException e)
            {
            	return 0;
            }
            return InternalState.GetMemory(index);
        }
        return 0;
    }
}
